<?php /**
 * Plugin Name: Export Users Data Distinct
 * Description: This Plugin allows you to export users data and metadata into XML, CSV, EXCEL and JSON file.
 * Author: Narola infotech solutions LLP
 * Version: 1.2
 * Requires at least: 5.2
 * Tested up to: 5.9
 * Requires PHP: 7.2.29
 * License:GPLv2
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) { die; }

// Add setting link into plugin listing page
add_filter('plugin_action_links_'.plugin_basename(__FILE__), 'eudd_users_page_link_settings');
function eudd_users_page_link_settings($links){
	$links[] = '<a href="'.admin_url('users.php').'">'.__('Export Users').'</a>';
	return $links;
}
// Add Button into admin side user list
function eudd_export_users(){
	$screen = get_current_screen();
	//Only add to users.php page
	if ( $screen->id != "users" )
		
	return;
	?>
	<script type="text/javascript">
		jQuery(document).ready( function($) {			
			jQuery('.tablenav.top .clear, .tablenav.bottom .clear').before('<form action="#" method="POST"><input class="button button-primary user_export_button" type="submit" name="forxml" value="Export All as XML" />&nbsp;<input class="button button-primary user_export_button" name="forcsv" type="submit" value="Export All as CSV" />&nbsp;<input class="button button-primary user_export_button" name="forexcel" type="submit" value="Export All as Excel" />&nbsp;<input class="button button-primary user_export_button" name="forjson" type="submit" value="Export All as JSON" /></form>');		
		});
	</script>
	<?php 
}
add_action('admin_footer','eudd_export_users');

function Export_Users_Data() {
	//For XML
	 if (isset($_POST['forxml']) == true) {	
		if (current_user_can('manage_options')) {
			// set header for XML file
			header("Content-type: text/xml");
			header('Content-Disposition: attachment; filename="Export_users_XML.xml"');
			$args = array (
				'order' => 'ASC',
				'orderby' => 'display_name',
				'fields' => 'all',
			);
			// The User Query
			$wp_users = get_users( $args );
			_e('<users>');
			// Array of WP_User objects.
			foreach ( $wp_users as $user ) {
				$user_id = $user->ID;
				$user_name = $user->user_login;
				$reg_date = $user->user_registered;
				$meta = get_user_meta($user_id);
				$role = $user->roles;
				$email = $user->user_email;
				$first_name = ( isset($meta['first_name'][0]) && $meta['first_name'][0] != '' ) ? $meta['first_name'][0] : 'NULL' ;
				$last_name  = ( isset($meta['last_name'][0]) && $meta['last_name'][0] != '' ) ? $meta['last_name'][0] : 'NULL' ;
				$nickname = ( isset($meta['nickname'][0]) && $meta['nickname'][0] != '' ) ? $meta['nickname'][0] : 'NULL' ;
				//Listing users data and metadata into XML file				
				_e("\n\t".'<user>'."\n\t\t");
					_e('<user_id>'.$user_id.'</user_id>'."\n\t\t".'<user_name>'.$user_name.'</user_name>'."\n\t\t".'<first_name>'.$first_name.'</first_name>'."\n\t\t".'<last_name>'.$last_name.'</last_name>'."\n\t\t".'<email>'.$email.'</email>'."\n\t\t".'<nickname>'.$nickname.'</nickname>'."\n\t\t".'<user_role>'.ucfirst($role[0]).'</user_role>'."\n\t\t".'<user_reg_date>'.$reg_date.'</user_reg_date>');
				_e("\n\t".'</user>');
			} 	
			_e("\n".'</users>');
			exit();
		}
	 }

	//For CSV
	if (isset($_POST['forcsv']) == true) {
		if (current_user_can('manage_options')) {
			// set header for CSV file
			header("Content-type: application/force-download");
			header('Content-Disposition: inline; filename="Export_users_CSV.csv"');

			$args = array (
				'order' => 'ASC',
				'orderby' => 'display_name',
				'fields' => 'all',
			);
			// The User Query
			$wp_users = get_users( $args );

			_e('" User_ID " " User_Name " " First_Name " " Last_Name " " Email_ID " " Nick_Name " " User_Role " " Registered_Date "' . "\r\n");
			// Array of WP_User objects.
			foreach ( $wp_users as $user ) {
				$user_id = $user->ID;
				$user_name = $user->user_login;
				$reg_date = $user->user_registered;
				$meta = get_user_meta($user_id);
				$role = $user->roles;
				$email = $user->user_email;

				$first_name = ( isset($meta['first_name'][0]) && $meta['first_name'][0] != '' ) ? $meta['first_name'][0] : 'NULL' ;
				$last_name  = ( isset($meta['last_name'][0]) && $meta['last_name'][0] != '' ) ? $meta['last_name'][0] : 'NULL' ;
				$nickname = ( isset($meta['nickname'][0]) && $meta['nickname'][0] != '' ) ? $meta['nickname'][0] : 'NULL' ;

				_e('" '.$user_id.' " " '.$user_name.' " " '.$first_name.' " " '.$last_name.' " " '.$email.'" "'.$nickname.'" "'.ucfirst($role[0]).'" " '.$reg_date.' " '."\r\n");
			}
			exit();
		}
	}
	//For EXCEL
	if (isset($_POST['forexcel']) == true) {
		if (current_user_can('manage_options')) {
			// set header for EXCEL file
			header("Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			header("Content-Disposition: attachment;filename=\"Export_users_EXCEL.xlsx\"");

			$args = array (
				'order' => 'ASC',
				'orderby' => 'display_name',
				'fields' => 'all',
			);
			// The User Query
			$wp_users = get_users( $args );
			_e('" User_ID " " User_Name " " First_Name " " Last_Name " " Email_ID " " Nick_Name " " User_Role " " Registered_Date "' . "\r\n");
			// Array of WP_User objects.
			foreach ( $wp_users as $user ) {
				$user_id = $user->ID;
				$user_name = $user->user_login;
				$reg_date = $user->user_registered;
				$meta = get_user_meta($user_id);
				$role = $user->roles;
				$email = $user->user_email;

				$first_name = ( isset($meta['first_name'][0]) && $meta['first_name'][0] != '' ) ? $meta['first_name'][0] : 'NULL' ;
				$last_name  = ( isset($meta['last_name'][0]) && $meta['last_name'][0] != '' ) ? $meta['last_name'][0] : 'NULL' ;
				$nickname = ( isset($meta['nickname'][0]) && $meta['nickname'][0] != '' ) ? $meta['nickname'][0] : 'NULL' ;

				_e('" '.$user_id.' " " '.$user_name.' " " '.$first_name.' " " '.$last_name.' " " '.$email.'" "'.$nickname.'" "'.ucfirst($role[0]).'" " '.$reg_date.' " '."\r\n");
			}
			exit();
		}
	}
	//For JSON
	if (isset($_POST['forjson']) == true) {	
		if (current_user_can('manage_options')) {
			// set header for JSON file
			header("Content-type: application/force-download");
			header('Content-Disposition: inline; filename="Export_users_JSON.JSON"');
			$args = array (
				'order' => 'ASC',
				'orderby' => 'display_name',
				'fields' => 'all',
			);
			// The User Query
			$wp_users = get_users( $args );
			$html="";
			$count_user=count($wp_users);
			_e('{"users":[');
			// Array of WP_User objects.
			foreach ( $wp_users as $user ) {
				$user_id = $user->ID;
				$user_name = $user->user_login;
				$reg_date = $user->user_registered;
				$meta = get_user_meta($user_id);
				$role = $user->roles;
				$email = $user->user_email;
				$first_name = ( isset($meta['first_name'][0]) && $meta['first_name'][0] != '' ) ? $meta['first_name'][0] : '' ;
				$last_name  = ( isset($meta['last_name'][0]) && $meta['last_name'][0] != '' ) ? $meta['last_name'][0] : '' ;
				$nickname = ( isset($meta['nickname'][0]) && $meta['nickname'][0] != '' ) ? $meta['nickname'][0] : '' ;
				//Listing users data and metadata into JSON file	
				 $html .="\n\t".'{';			
				$html.='"user_id":"'.$user_id.'","user_name":"'.$user_name.'","first_name":"'.$first_name.'","last_name":"'.$last_name.'","email":"'.$email.'","nickname":"'.$nickname.'","role":"'.ucfirst($role[0]).'","reg_date":" '.$reg_date.'"}';
				 if(1<$count_user){
				 	$count_user--;
					$html.=',';
				}else{	
					$html.=' '; 
				}								 
			} 	
			$html.="\n".']}';
			_e($html);
			exit();
		}
	}	 
}
add_action('admin_init','Export_Users_Data');
//you can use admin_init as well
?>